package org.rcisoft.bus.jnP7sj.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.bus.jnP7sj.dto.jnP7sjExportTemplateDto;
import org.rcisoft.bus.jnsp7xtm.vo.Jnsp7xtmVo;
import org.rcisoft.core.entity.CyIdIncreEntity;

import java.math.BigDecimal;

@Data
@TableName("jnsp7xtm_dqsj")
public class jnP7sj extends CyIdIncreEntity<jnP7sj> {


    @Excel(name = "term", orderNum = "0", width = 20)
    private String term;


    @Excel(name = "half", orderNum = "1", width = 20)
    private String half;

    @Excel(name = "quarter", orderNum = "2", width = 20)
    private String quarter;

    @Excel(name = "month", orderNum = "3", width = 20)
    private String month;


    @Excel(name = "cc", orderNum = "4", width = 20)
    private String cc;


    @Excel(name = "cn", orderNum = "5", width = 20)
    private String cn;


    @Excel(name = "io", orderNum = "6", width = 20)
    private String io;


    @Excel(name = "route", orderNum = "7", width = 20)
    private String route;


    @Excel(name = "pc", orderNum = "8", width = 20)
    private String pc;


    @Excel(name = "sypn", orderNum = "8", width = 20)
    private String sypn;


    @Excel(name = "factory", orderNum = "9", width = 20)
    private String factory;


    @Excel(name = "size", orderNum = "10", width = 20)
    private String size;


    @Excel(name = "pn", orderNum = "11", width = 20)
    private String pn;

    @Excel(name = "po", orderNum = "12", width = 20)
    private BigDecimal po;

    @Excel(name = "fc", orderNum = "13", width = 20)
    private BigDecimal fc;

    @Excel(name = "qty", orderNum = "14", width = 20)
    private BigDecimal qty;


    @Excel(name = "up", orderNum = "15", width = 20)
    private BigDecimal up;


    @Excel(name = "currency", orderNum = "16", width = 20)
    private String currency;

    @Excel(name = "rate", orderNum = "17", width = 20)
    private BigDecimal rate;


    @Excel(name = "amt", orderNum = "18", width = 20)
    private BigDecimal amt;

    @Excel(name = "custGroup", orderNum = "19", width = 20)
    private String custGroup;

    @Excel(name = "custGroup2", orderNum = "20", width = 20)
    private String custGroup2;

    @Excel(name = "custRt1", orderNum = "21", width = 20)
    private String custRt1;


    @Excel(name = "custIo", orderNum = "22", width = 20)
    private String custIo;

    @Excel(name = "custNewpic", orderNum = "23", width = 20)
    private String custNewpic;

    @Excel(name = "custGroup1", orderNum = "24", width = 20)
    private String custGroup1;

    @Excel(name = "custRt2", orderNum = "25", width = 20)
    private String custRt2;

    @Excel(name = "custRout", orderNum = "26", width = 20)
    private String custRout;

    @Excel(name = "custAddr", orderNum = "27", width = 20)
    private String custAddr;


    @Excel(name = "custG0", orderNum = "28", width = 20)
    private String custG0;


    @Excel(name = "custG20", orderNum = "29", width = 20)
    private String custG20;


    @Excel(name = "custG30", orderNum = "30", width = 20)
    private String custG30;


    @Excel(name = "custG201", orderNum = "31", width = 20)
    private String custG201;


    @Excel(name = "custSave", orderNum = "32", width = 20)
    private String custSave;


    @Excel(name = "custStype", orderNum = "33", width = 20)
    private String custStype;


    @Excel(name = "custG1", orderNum = "34", width = 20)
    private String custG1;

    @Excel(name = "custYj", orderNum = "35", width = 20)
    private String custYj;


    @Excel(name = "custYj2", orderNum = "36", width = 20)
    private String custYj2;

    @Excel(name = "custYj3", orderNum = "37", width = 20)
    private String custYj3;

    @Excel(name = "custGc", orderNum = "38", width = 20)
    private String custGc;

    public static final String TERM_C = "C";

    public static final String TERM_L = "L";

    public static jnP7sj generatejnP7sj(Jnsp7xtmVo jnsp7xtmVo){
        jnP7sj jnP7sj = new jnP7sj();
        // y.cust_group  -  cust_gc 20项
        BeanUtil.copyProperties(jnsp7xtmVo,jnP7sj);
        jnP7sj.setTerm(TERM_C);
        jnP7sj.setMonth(jnsp7xtmVo.getNqy());
          /*
               if(x.nqy = xxxx04 ... 09)  y.half = 1H
               if(x.nqy = xxxx10 ... 03)  y.half = 2H
          */
        String lastTwoNqy = "";
        if (StringUtils.isNotBlank(jnsp7xtmVo.getNqy()) && jnsp7xtmVo.getNqy().length() > 2) {
            lastTwoNqy = jnsp7xtmVo.getNqy().substring(jnsp7xtmVo.getNqy().length() - 2);
            if (lastTwoNqy.equals("04") || lastTwoNqy.equals("05") || lastTwoNqy.equals("06") || lastTwoNqy.equals("07") || lastTwoNqy.equals("08") || lastTwoNqy.equals("09")) {
                jnP7sj.setHalf("1H");
            } else {
                jnP7sj.setHalf("2H");
            }
               /*
                    if(x.nqy = xxxx04 ... 06)  y.quarter = Q1
                    if(x.nqy = xxxx07 ... 09)  y.quarter = Q2
                    if(x.nqy = xxxx10 ... 12)  y.quarter = Q3
                    if(x.nqy = xxxx01 ... 03)  y.quarter = Q4
                */
            if (lastTwoNqy.equals("01") || lastTwoNqy.equals("02") || lastTwoNqy.equals("03")) {
                jnP7sj.setQuarter("Q4");
            } else if (lastTwoNqy.equals("04") || lastTwoNqy.equals("05") || lastTwoNqy.equals("06")) {
                jnP7sj.setQuarter("Q1");
            } else if (lastTwoNqy.equals("07") || lastTwoNqy.equals("08") || lastTwoNqy.equals("09")) {
                jnP7sj.setQuarter("Q2");
            } else if (lastTwoNqy.equals("10") || lastTwoNqy.equals("11") || lastTwoNqy.equals("12")) {
                jnP7sj.setQuarter("Q3");
            }
            jnP7sj.setCc(jnsp7xtmVo.getKhdm());
            jnP7sj.setCn(jnsp7xtmVo.getKhm());
            //  if(x.xslj == "W0") ? y.io = I: y.io = O
            if (StringUtils.isNotBlank(jnsp7xtmVo.getXslj())) {
                if (jnsp7xtmVo.getXslj().equals("W0"))
                    jnP7sj.setIo("I");
                else
                    jnP7sj.setIo("o");
            }
            jnP7sj.setRoute(jnsp7xtmVo.getXslj());
            jnP7sj.setPc(jnsp7xtmVo.getZd());
            //   if(x.zd == "CR" || WR || MP) ?  y.factory = "CC1" :  y.factory = "CC2"
            if (StringUtils.isNotBlank(jnsp7xtmVo.getZd())) {
                if (jnsp7xtmVo.getZd().equals("CR") || jnsp7xtmVo.getZd().equals("WR") || jnsp7xtmVo.getZd().equals("MP"))
                    jnP7sj.setFactory("CC1");
                else
                    jnP7sj.setFactory("CC2");
            }
            jnP7sj.setSize(jnsp7xtmVo.getJlpm());
            jnP7sj.setPn(jnsp7xtmVo.getPn());
            jnP7sj.setSypn(jnsp7xtmVo.getSypn());
            jnP7sj.setPo(new BigDecimal(jnsp7xtmVo.getZzc()));
            //   y.qty = y.po + y.fc (BigDecimal)
            if (jnP7sj.getPo() != null && jnP7sj.getFc() != null) {
                jnP7sj.setQty(jnP7sj.getPo().add(jnP7sj.getFc()) );
            }
            jnP7sj.setUp(new BigDecimal(jnsp7xtmVo.getXsjg()));
            jnP7sj.setCurrency(jnsp7xtmVo.getBz());
            jnP7sj.setAmt(new BigDecimal(jnsp7xtmVo.getRmb()));
        }
        return jnP7sj;
    }
    public static jnP7sj generatejnP7sj(jnP7sjExportTemplateDto jnP7sjExportTemplateDto,jnP7sj jnP7sj) {
        BeanUtil.copyProperties(jnP7sjExportTemplateDto,jnP7sj);
        if (StringUtils.isEmpty(jnP7sjExportTemplateDto.getTerm()))
            jnP7sj.setTerm(TERM_L);
        String lastTwoNqy = "";
        if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getMonth()) &&jnP7sjExportTemplateDto.getMonth().length() > 2 ) {
            lastTwoNqy = jnP7sjExportTemplateDto.getMonth().substring(jnP7sjExportTemplateDto.getMonth().length() - 2);
            if (lastTwoNqy.equals("04") || lastTwoNqy.equals("05") || lastTwoNqy.equals("06") || lastTwoNqy.equals("07") || lastTwoNqy.equals("08") || lastTwoNqy.equals("09")) {
                jnP7sj.setHalf("1H");
            } else {
                jnP7sj.setHalf("2H");
            }
            if (lastTwoNqy.equals("01") || lastTwoNqy.equals("02") || lastTwoNqy.equals("03")) {
                jnP7sj.setQuarter("Q4");
            } else if (lastTwoNqy.equals("04") || lastTwoNqy.equals("05") || lastTwoNqy.equals("06")) {
                jnP7sj.setQuarter("Q1");
            } else if (lastTwoNqy.equals("07") || lastTwoNqy.equals("08") || lastTwoNqy.equals("09")) {
                jnP7sj.setQuarter("Q2");
            } else if (lastTwoNqy.equals("10") || lastTwoNqy.equals("11") || lastTwoNqy.equals("12")) {
                jnP7sj.setQuarter("Q3");
            }
            if (StringUtils.isNotBlank(jnP7sjExportTemplateDto.getRoute())) {
                if (jnP7sjExportTemplateDto.getRoute().equals("W0"))
                    jnP7sj.setIo("I");
                else
                    jnP7sj.setIo("o");
            }
            if (StringUtils.isNotBlank(jnP7sjExportTemplateDto.getPc())) {
                if (jnP7sjExportTemplateDto.getPc().equals("CR") || jnP7sjExportTemplateDto.getPc().equals("WR") || jnP7sjExportTemplateDto.getPc().equals("MP"))
                    jnP7sj.setFactory("CC1");
                else
                    jnP7sj.setFactory("CC2");
            }
            /**
             * 将string 转换成 BigDecimal类型
             * **/
            if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getAmt())) {
                jnP7sj.setAmt(new BigDecimal(jnP7sjExportTemplateDto.getAmt()));
            }
            if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getRate())) {
                jnP7sj.setRate(new BigDecimal(jnP7sjExportTemplateDto.getRate()));
            }
            if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getUp())) {
                jnP7sj.setUp(new BigDecimal(jnP7sjExportTemplateDto.getUp()));
            }
            if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getFc())) {
                jnP7sj.setFc(new BigDecimal(jnP7sjExportTemplateDto.getFc()));
                jnP7sj.setQty(jnP7sj.getFc());
            }
            if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getPo())) {
                jnP7sj.setPo(new BigDecimal(jnP7sjExportTemplateDto.getPo()));
                jnP7sj.setQty(jnP7sj.getPo());
            }
            //   y.qty = y.po + y.fc (BigDecimal)
            if (StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getPo()) && StringUtils.isNotEmpty(jnP7sjExportTemplateDto.getFc())) {
                jnP7sj.setQty(new BigDecimal(jnP7sjExportTemplateDto.getPo()).add(new BigDecimal(jnP7sjExportTemplateDto.getFc())));
            }
        }
        return jnP7sj;
    }

}





